<!-- Example widget for demonstration  -->
<script lang="ts">
	import { onDestroy, onMount } from 'svelte';
	import { slide } from 'svelte/transition';
	import { ws } from '$lib/config';
	import { quintOut } from 'svelte/easing';
	import Counter from '../Counter..svelte';
	import type { Donor } from '$lib/donors';
	import ReconnectingWebSocket from 'reconnecting-websocket';

	// This URI should work : http://localhost:5173/tops-global

	let tops: Donor[];
	let last: Donor;
	let selected: string = 'top';
	let selectedInterval: number;

	function select() {
		if (selected === 'top') {
			selected = 'last';
		} else if (selected === 'last') {
			selected = 'top';
		}
	}

	onMount(async () => {
		selectedInterval = setInterval(() => select(), 20000);
		// Start WS
		const socket = new ReconnectingWebSocket(ws());

		socket.addEventListener('open', function (event) {
			socket.send(JSON.stringify({ op: 'sub', msg: `tops.global` }));
			socket.send(JSON.stringify({ op: 'sub', msg: `teams.*.don` }));
		});

		socket.addEventListener('message', function (event) {
			let data = JSON.parse(event.data);
			switch (data.r) {
				case `tops.global`:
					tops = data.d.dons;
					break;
				case `teams.1.don`:
				case `teams.2.don`:
				case `teams.3.don`:
				case `teams.0.don`:
					last = !last || data.d.don.time > last.time ? data.d.don : last;
					break;
				case `refresh`:
					// Refresh the page
					setTimeout(() => {
						window.location.reload();
					}, Math.random() * 1000);
					break;
			}
		});
	});

	onDestroy(() => {
		clearInterval(selectedInterval);
	});
</script>

{#if tops && last}
	<div class="flex flex-col justify-center items-center">
		<h1 class="text-2xl text-white flex flex-col items-center">
			{#if selected === 'top'}
				<p
					class=" fredoka-bold"
					in:slide={{ delay: 250, duration: 300, easing: quintOut, axis: 'y' }}
					out:slide={{ delay: 250, duration: 300, easing: quintOut, axis: 'y' }}
				>
					Top Donateur :
				</p>
			{:else if selected === 'last'}
				<p
					class=" fredoka-bold"
					in:slide={{ delay: 250, duration: 300, easing: quintOut, axis: 'y' }}
					out:slide={{ delay: 250, duration: 300, easing: quintOut, axis: 'y' }}
				>
					Dernier Donateur :
				</p>
			{/if}
		</h1>
		<div class="background-frame flex flex-row justify-center">
			{#if selected === 'top'}
				<div
					class="top-donateur text-item text-3xl"
					in:slide={{ delay: 550, duration: 300, easing: quintOut, axis: 'x' }}
					out:slide={{ delay: 250, duration: 300, easing: quintOut, axis: 'x' }}
				>
					<div class="donateur fredoka">
						{(tops[0]?.first_name || 'John') + ' ' + (tops[0]?.last_name || 'Doe')}
					</div>
					<div class="top-amount flex red-hat">
						<p class=" fredoka">-</p>
						<Counter amount={tops[0]?.amount} />
						<p class=" fredoka">€</p>
					</div>
				</div>
			{:else if selected === 'last'}
				<p
					class="donateur text-item text-3xl fredoka"
					in:slide={{ delay: 550, duration: 300, easing: quintOut, axis: 'x' }}
					out:slide={{ delay: 250, duration: 300, easing: quintOut, axis: 'x' }}
				>
					{last.first_name + ' ' + last.last_name}
				</p>
			{/if}
		</div>
	</div>
{/if}

<style lang="scss">
	@import url('https://fonts.googleapis.com/css2?family=Red+Hat+Mono:wght@700&display=swap');
	@import url('https://fonts.googleapis.com/css2?family=Fredoka:wght@300..700&display=swap');
	.red-hat {
		font-family: 'Red Hat Mono', monospace;
		font-optical-sizing: auto;
		font-weight: 700;
		font-style: normal;
	}
	.fredoka {
		font-family: 'Fredoka', sans-serif;
		font-optical-sizing: auto;
		font-weight: 500;
		font-style: normal;
		font-variation-settings: 'wdth' 100;
	}
	.fredoka-bold {
		font-family: 'Fredoka', sans-serif;
		font-optical-sizing: auto;
		font-weight: 700;
		font-style: normal;
		font-variation-settings: 'wdth' 100;
		margin: 0 1rem;
	}
	.top-donateur {
		display: flex;
		gap: 5px;
		.donateur {
			flex: 1 1 auto;
			text-overflow: ellipsis;
			white-space: nowrap;
			word-break: break-all;
			overflow: hidden;
		}
		.top-amount {
			flex: 0 1 50px;
			gap: 5px;
		}
	}
	.text-item {
		text-overflow: ellipsis;
		white-space: nowrap;
		word-break: break-all;
		overflow: hidden;
		margin: 0 2px 0 0;
	}
	.background-frame {
		padding: 4px 16px;
		min-width: 358px;
		max-width: 358px;
		word-break: break-all;
		position: relative;
		box-sizing: border-box;
		border: 5px;
		color: #fff;
		background: #444;
		background-clip: padding-box; /* !importanté */
		border: solid 5px transparent; /* !importanté */
		border-radius: 30px;

		&:before {
			content: '';
			position: absolute;
			top: 0;
			right: 0;
			bottom: 0;
			left: 0;
			z-index: -1;
			margin: -5px; /* !importanté */
			border-radius: inherit; /* !importanté */
			background: linear-gradient(to right, #38a17e, #00537e);
		}
	}
</style>
